<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>ランキング</title>
</head>
<body>

<?php
//php開始

//POSTされた値「scoreVal」を取得
$scoreVal = $_POST["scoreVal"];
//POSTされた値「score」を取得
$score = $_POST["score"];
//POSTされた値「name」を取得
$name = $_POST["name"];
//問題のある文字を削除
$name = str_replace(array("#S#","<",">","#rc#","\r\n","\r","\n","\"","\'","\&","\\"), '', $name);

//変数「$name」に値が入っている場合
if ( $name != "" )
{
	//ランキング登録
	writeRank($score,$name);
	//ランキング表示
	showRank();
}
//変数「$name」に値が入っておらず、変数「$score」に値が入っている場合
else if ( $score != "" )
{
	//名前が入力されていなかったので、入力を促す
	print("<font color=\"#ff0000\">名前を入力してください！</font><br />");
	//ランキングに名前とスコア登録
	writeName($score);
}
//変数「$name」に値が入っておらず、変数「$score」にも値が入っていない場合
else
{
	//ゲームから値がPOSTされていない場合
	if ( $scoreVal == "" )
	{
		//ランキング表示
		showRank();
	}
	//ゲームから値がPOSTされている場合
	else
	{
		//名前とスコア登録
		writeName($scoreVal);
	}
}

//ランキング登録
function writeRank($score,$name)
{
	//変数$iに0
	$i = 0;
	//ログファイルを読み込み専用でオープンする
	$lines = file('tmp/log.txt');
	//ライン数だけループ
	foreach ($lines as $l)
	{
		//「#S#」で分割
		$op=split("#S#",$l);
		//分割した「0」個目
		$scoreArray[$i] = $op[0];
		//分割した「1」個目
		$nameArray[$i] = $op[1];
		//変数$iインクリメント
		$i++;
	}
	//ログファイルを書き込むためにオープン
	$fp=fopen("tmp/log.txt","w");
	//フラグにfalse
	$flg = false;
	//最高19回か、$iより値が小さい場合ループ
	for ( $j = 0; $j < $i && $j < 19; $j++ )
	{
		//今回スコアが今までのスコアより高得点だった場合
		if ( !$flg && $score >= $scoreArray[$j] )
		{
			//フラグにtrue
			$flg = true;
			//今回のスコアと名前
			$str=sprintf("%s#S#%s#S#\n",$score,$name);
			//$str文字列をファイルに出力
			fputs($fp,$str);
			//スコアと名前
			$str=sprintf("%s#S#%s#S#\n",$scoreArray[$j],$nameArray[$j]);
			//$str文字列をファイルに出力
			fputs($fp,$str);
		}
		//今回のスコアより今までのスコアの方が高得点だった場合
		else
		{
			//スコアと名前
			$str=sprintf("%s#S#%s#S#\n",$scoreArray[$j],$nameArray[$j]);
			//$str文字列をファイルに出力
			fputs($fp,$str);
		}
	}
	//今までの全てのスコアの方が今回のスコアより高得点だった場合
	if ( !$flg )
	{
		//今回のスコアと名前を20位に
		$str=sprintf("%s#S#%s#S#\n",$score,$name);
			//$str文字列をファイルに出力
		fputs($fp,$str);
	}
	//ファイルを閉じる
	fclose($fp);
}

//ランキング表示
function showRank()
{
	//テーブルのヘッダー
	print('<table border=\"1\"><tr><th>順位</th><th>スコア</th><th>名前</th></tr>');
	//変数$iに0を
	$i = 0;
	//ログファイルを開く
	$lines = file('tmp/log.txt');
	//ラインの数だけループ
	foreach ($lines as $l)
	{
		//1行ごとに「#S#」で分割
		$op=split("#S#",$l);
		//分割した「0」個目
		$score=$op[0];
		//分割した「1」個目
		$name=$op[1];
		//変数$iインクリメント
		$i++;
		//スコアと名前を表示
		print('<tr><td>'.$i.'</td><td>'.$score.'</td><td>'.$name.'</td></tr>');
	}
	//テーブル終了
	print('</table><br />');
}

//名前登録
function writeName($val)
{
	//スコア表示
	print("あなたのスコア".$val."点<br />");
	//POSTするためのFORM
	print('<form method="post" action="./ranking.php">');
	//名前を入力するテキストボックス
	print('<input type="text" name="name" value="" maxlength="20" /><br />');
	//登録ボタン
	print('<input type="submit" value="名前入力" class="submit" />');
	//スコアを隠して値を渡す
    print('<input type="hidden" name="score" value='.$val.' />');
	//FORM終了
	print('</form>');
}

//php終了
?>

</body>
</html>
